Index: XIOS/dev/dev_trunk_omp/src/attribute.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/attribute.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/attribute.hpp	(revision 1680)
@@ -42,4 +42,5 @@
             virtual void fromString(const StdString & str) = 0;
             virtual StdString dump(void) const = 0;
+            virtual StdString dump2(void) const = 0;
             virtual bool isEqual(const CAttribute& ) = 0;
 
Index: XIOS/dev/dev_trunk_omp/src/attribute_array.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/attribute_array.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/attribute_array.hpp	(revision 1680)
@@ -56,4 +56,5 @@
             virtual bool fromBuffer(CBufferIn& buffer) { return _fromBuffer(buffer); }
             virtual string dump(void) const { return _dump();}
+            virtual string dump2(void) const { return _dump2();}
 
             virtual void generateCInterface(ostream& oss,const string& className) ;
@@ -71,4 +72,5 @@
           StdString _toString(void) const;
           StdString _dump(void) const;
+          StdString _dump2(void) const;
           void _fromString(const StdString & str);
           bool _toBuffer  (CBufferOut& buffer) const;
Index: XIOS/dev/dev_trunk_omp/src/attribute_array_impl.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/attribute_array_impl.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/attribute_array_impl.hpp	(revision 1680)
@@ -138,4 +138,13 @@
     }
 
+    template <typename T_numtype, int N_rank>
+    StdString CAttributeArray<T_numtype,N_rank>::_dump2(void) const
+    {
+      StdOStringStream oss;
+      if (! isEmpty() && this->hasId() && (this->numElements()!=0))
+        oss << this->getName() << "=" << CArray<T_numtype, N_rank>::dump() << "";
+      return (oss.str());
+    }
+
 
       template <typename T_numtype, int N_rank>
Index: XIOS/dev/dev_trunk_omp/src/attribute_enum.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/attribute_enum.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/attribute_enum.hpp	(revision 1680)
@@ -63,4 +63,5 @@
             virtual void fromString(const StdString & str) { if (str==resetInheritanceStr) { reset(); _canInherite=false ;}  else _fromString(str);}
             virtual StdString dump(void) const { return _toString();}
+            virtual StdString dump2(void) const { return _dump2();}
 
             virtual bool toBuffer  (CBufferOut& buffer) const { return _toBuffer(buffer);} 
@@ -79,4 +80,5 @@
           bool isEqual_(const CAttributeEnum& attr );
           StdString _toString(void) const;
+          StdString _dump2(void) const;
           void _fromString(const StdString & str);
           bool _toBuffer  (CBufferOut& buffer) const;
Index: XIOS/dev/dev_trunk_omp/src/attribute_enum_impl.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/attribute_enum_impl.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/attribute_enum_impl.hpp	(revision 1680)
@@ -149,4 +149,15 @@
   }
 
+
+  template <class T>
+  StdString CAttributeEnum<T>::_dump2(void) const
+  {
+     StdOStringStream oss;
+     if (!CEnum<T>::isEmpty() && this->hasId())
+        oss << this->getName() << "=" << CEnum<T>::toString() << "</br>";
+     return (oss.str());
+  }
+
+
   template <class T>
   void CAttributeEnum<T>::_fromString(const StdString & str)
Index: XIOS/dev/dev_trunk_omp/src/attribute_map.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/attribute_map.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/attribute_map.cpp	(revision 1680)
@@ -48,4 +48,31 @@
             {
               str.append(att.second->dump());
+              str.append(" ");
+            }
+            else if (str.length() == maxNbChar)
+            {
+              str.append("...");
+            }
+          }
+        }
+        return str;
+      }
+
+
+
+      StdString CAttributeMap::recordXiosAttributes(void) const
+      {
+        int maxNbChar = 250;
+        StdString str;
+        typedef std::pair<StdString, CAttribute*> StdStrAttPair;
+        auto it = SuperClassMap::begin(), end = SuperClassMap::end();
+        for (; it != end; it++)
+        {
+          const StdStrAttPair& att = *it;
+          if (!att.second->isEmpty())
+          {
+            if (str.length() < maxNbChar)
+            {
+              str.append(att.second->dump2());
               str.append(" ");
             }
Index: XIOS/dev/dev_trunk_omp/src/attribute_map.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/attribute_map.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/attribute_map.hpp	(revision 1680)
@@ -39,4 +39,5 @@
             void clearAllAttributes(void);
             StdString dumpXiosAttributes(void) const;
+            StdString recordXiosAttributes(void) const;
 
             void clearAttribute(const StdString& key);
Index: XIOS/dev/dev_trunk_omp/src/attribute_template.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/attribute_template.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/attribute_template.hpp	(revision 1680)
@@ -74,4 +74,5 @@
 //            virtual void fromBinary(StdIStream & is);
             virtual StdString dump(void) const { return _dump();}
+            virtual StdString dump2(void) const { return _dump2();}
 
             virtual bool toBuffer  (CBufferOut& buffer) const { return _toBuffer(buffer);}
@@ -99,4 +100,5 @@
           StdString _toString(void) const;
           StdString _dump(void) const;
+          StdString _dump2(void) const;
           void _fromString(const StdString & str);
           bool _toBuffer  (CBufferOut& buffer) const;
Index: XIOS/dev/dev_trunk_omp/src/attribute_template_impl.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/attribute_template_impl.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/attribute_template_impl.hpp	(revision 1680)
@@ -208,4 +208,13 @@
          if (!CType<T>::isEmpty() && this->hasId())
             oss << this->getName() << "=\"" << CType<T>::dump() << "\"";
+         return (oss.str());
+      }
+
+      template <class T>
+         StdString CAttributeTemplate<T>::_dump2(void) const
+      {
+         StdOStringStream oss;
+         if (!CType<T>::isEmpty() && this->hasId())
+            oss << this->getName() << "=" << CType<T>::dump() << "</br>";
          return (oss.str());
       }
Index: XIOS/dev/dev_trunk_omp/src/cxios.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/cxios.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/cxios.cpp	(revision 1680)
@@ -174,10 +174,10 @@
        
        // CGraphviz::showStaticWorkflowGraph();
-       CGraphviz::buildWorkflowGraphDot();
+       // CGraphviz::buildWorkflowGraphDot();
        CGraphviz::buildWorkflowGraphVisjs_with_info();
 
-      StdString commande_string="dot -Tpdf graph.dot -o graph.pdf";  
-      const char* command=commande_string.c_str();
-      system(command);
+      // StdString commande_string="dot -Tpdf graph.dot -o graph.pdf";  
+      // const char* command=commande_string.c_str();
+      // system(command);
 
   
Index: XIOS/dev/dev_trunk_omp/src/filter/binary_arithmetic_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/binary_arithmetic_filter.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/binary_arithmetic_filter.cpp	(revision 1680)
@@ -1,4 +1,6 @@
 #include "binary_arithmetic_filter.hpp"
 #include "workflow_graph.hpp"
+#include "yacc_var.hpp"
+#include "file.hpp"
 
 
@@ -10,27 +12,5 @@
     , value(value)
   { 
-    StdString input_op_expression=op;
-    if(input_op_expression == "add")
-      op_expression = "+";
-    else if(input_op_expression == "minus")
-      op_expression = "-";
-    else if(input_op_expression == "mult")
-      op_expression = "x";
-    else if(input_op_expression == "div")
-      op_expression = "/";
-    else if(input_op_expression == "eq")
-      op_expression = "=";
-    else if(input_op_expression == "lt")
-      op_expression = "<";
-    else if(input_op_expression == "gt")
-      op_expression = ">";
-    else if(input_op_expression == "le")
-      op_expression = "<=";
-    else if(input_op_expression == "ge")
-      op_expression = ">=";
-    else if(input_op_expression == "ne")
-      op_expression = "!=";
-    else
-      op_expression = " ";
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
   };
 
@@ -38,29 +18,52 @@
   {
     bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    // bool building_graph = true;
+    int unique_filter_id;
 
     if(building_graph)
     {
-      this->filterID = InvalidableObject::filterIdGenerator++;   
-      int edgeID = InvalidableObject::edgeIdGenerator++; 
-
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
-
-      std::cout<<"CScalarFieldArithmeticFilter::apply filter tag = "<<this->tag<<std::endl;
-
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "S "+op_expression +" F Filter" ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 2 ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1 ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 1 ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp ;
-
-      if(CWorkflowGraph::build_begin)
-      {
-        CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
-
-        (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+      CWorkflowGraph::allocNodeEdge();
+
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->recordXiosAttributes();
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->recordXiosAttributes();
+      
+
+        if(CWorkflowGraph::build_begin)
+        {
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+        }
+        else CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
       }
-      else CWorkflowGraph::build_begin = true;
+      // not first round
+      else 
+      {
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+      
+        
+      }  
     }
 
@@ -69,5 +72,5 @@
     packet->timestamp = data[0]->timestamp;
     packet->status = data[0]->status;
-    if(building_graph) packet->src_filterID = this->filterID;
+    if(building_graph) packet->src_filterID = unique_filter_id;
     packet->field = this->field;
 
@@ -83,29 +86,5 @@
     , value(value)
   { 
-    StdString input_op_expression=op;
-    if(input_op_expression == "add")
-      op_expression = "+";
-    else if(input_op_expression == "minus")
-      op_expression = "-";
-    else if(input_op_expression == "mult")
-      op_expression = "x";
-    else if(input_op_expression == "div")
-      op_expression = "/";
-    else if(input_op_expression == "pow")
-      op_expression = "^";
-    else if(input_op_expression == "eq")
-      op_expression = "=";
-    else if(input_op_expression == "lt")
-      op_expression = "<";
-    else if(input_op_expression == "gt")
-      op_expression = ">";
-    else if(input_op_expression == "le")
-      op_expression = "<=";
-    else if(input_op_expression == "ge")
-      op_expression = ">=";
-    else if(input_op_expression == "ne")
-      op_expression = "!=";
-    else
-      op_expression = " ";
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
   };
 
@@ -113,29 +92,52 @@
   {
     bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    // bool building_graph = true;
+    int unique_filter_id;
 
     if(building_graph)
     {
-      this->filterID = InvalidableObject::filterIdGenerator++;
-      int edgeID = InvalidableObject::edgeIdGenerator++;
- 
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
-
-      std::cout<<"CFieldScalarArithmeticFilter::apply filter tag = "<<this->tag<<std::endl;
-
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "F "+op_expression +" S Filter" ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 2 ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1 ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 1 ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp ;
-
-      if(CWorkflowGraph::build_begin)
-      {
-        CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
-
-        (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+      CWorkflowGraph::allocNodeEdge();
+
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->recordXiosAttributes();
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->recordXiosAttributes();
+      
+
+        if(CWorkflowGraph::build_begin)
+        {
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+        }
+        else CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
       }
-      else CWorkflowGraph::build_begin = true;
+      // not first round
+      else 
+      {
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+      
+        
+      }  
     }
 
@@ -144,5 +146,5 @@
     packet->timestamp = data[0]->timestamp;
     packet->status = data[0]->status;
-    if(building_graph) packet->src_filterID = this->filterID;
+    if(building_graph) packet->src_filterID = unique_filter_id;
     packet->field = this->field;
     
@@ -158,29 +160,5 @@
     , op(operatorExpr.getOpFieldField(op))
   { 
-    StdString input_op_expression=op;
-    if(input_op_expression == "add")
-      op_expression = "+";
-    else if(input_op_expression == "minus")
-      op_expression = "-";
-    else if(input_op_expression == "mult")
-      op_expression = "x";
-    else if(input_op_expression == "div")
-      op_expression = "/";
-    else if(input_op_expression == "pow")
-      op_expression = "^";
-    else if(input_op_expression == "eq")
-      op_expression = "=";
-    else if(input_op_expression == "lt")
-      op_expression = "<";
-    else if(input_op_expression == "gt")
-      op_expression = ">";
-    else if(input_op_expression == "le")
-      op_expression = "<=";
-    else if(input_op_expression == "ge")
-      op_expression = ">=";
-    else if(input_op_expression == "ne")
-      op_expression = "!=";
-    else
-      op_expression = " ";
+    expression.assign(*yacc_globalInputText_ptr, 0, yacc_globalInputText_ptr->size()-1);
   };
 
@@ -188,36 +166,66 @@
   {
     bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph : false;
+    // bool building_graph = true;
+    int unique_filter_id;
 
     if(building_graph)
-    {
-
-      this->filterID = InvalidableObject::filterIdGenerator++;
-      int edgeID = InvalidableObject::edgeIdGenerator++;
-   
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
+    {  
+      CWorkflowGraph::allocNodeEdge();
 
       std::cout<<"CFieldFieldArithmeticFilter::apply filter tag = "<<this->tag<<std::endl;
 
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "F "+op_expression +" F Filter" ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 2 ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1 ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 2 ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date ;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp ;
-
-      if(CWorkflowGraph::build_begin)
-      {
-
-        CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
-
-        edgeID = InvalidableObject::edgeIdGenerator++;
-
-        CWorkflowGraph::addEdge(edgeID, this->filterID, data[1]);
-
-        (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
-        (*CWorkflowGraph::mapFilters_ptr_with_info)[data[1]->src_filterID].filter_filled = 0 ;
+      size_t filterhash = std::hash<StdString>{}(expression+to_string(data[0]->timestamp)+this->field->getId());
+
+      // first round
+      if(CWorkflowGraph::mapHashFilterID_ptr->find(filterhash) == CWorkflowGraph::mapHashFilterID_ptr->end())
+      {
+        this->filterID = InvalidableObject::filterIdGenerator++;
+        int edgeID = InvalidableObject::edgeIdGenerator++;
+    
+        CWorkflowGraph::addNode(this->filterID, "Arithmetic Filter\\n("+expression+")", 3, 1, 0, data[0]);
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->recordXiosAttributes();
+        if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->recordXiosAttributes();
+    
+        (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_tag = this->tag;
+        if(CWorkflowGraph::build_begin)
+        {
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[0]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          edgeID = InvalidableObject::edgeIdGenerator++;
+
+          CWorkflowGraph::addEdge(edgeID, this->filterID, data[1]);
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb ++;
+
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[1]->src_filterID].filter_filled = 0 ;
+        }
+        CWorkflowGraph::build_begin = true;
+
+        (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash] = this->filterID; 
+        unique_filter_id = this->filterID;
+ 
       }
-      CWorkflowGraph::build_begin = true;
+      // not first round
+      else 
+      {
+        unique_filter_id = (*CWorkflowGraph::mapHashFilterID_ptr)[filterhash];
+        if(data[0]->src_filterID != unique_filter_id)
+        {
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[0]); 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[0]->src_filterID].filter_filled = 0 ; 
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+        if(data[1]->src_filterID != unique_filter_id)
+        { 
+          int edgeID = InvalidableObject::edgeIdGenerator++;
+          CWorkflowGraph::addEdge(edgeID, unique_filter_id, data[1]);  
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[data[1]->src_filterID].filter_filled = 0 ;
+          (*CWorkflowGraph::mapFilters_ptr_with_info)[unique_filter_id].expected_entry_nb ++;
+        }
+        
+      }  
     }
 
@@ -226,5 +234,5 @@
     packet->date = data[0]->date;
     packet->timestamp = data[0]->timestamp;
-    if(building_graph) packet->src_filterID = this->filterID;
+    if(building_graph) packet->src_filterID = unique_filter_id;
     packet->field = this->field;
     
Index: XIOS/dev/dev_trunk_omp/src/filter/file_writer_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/file_writer_filter.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/file_writer_filter.cpp	(revision 1680)
@@ -22,4 +22,5 @@
   {
     bool building_graph = this->tag ? data[0]->timestamp >= this->start_graph && data[0]->timestamp <= this->end_graph: false;
+    
     if(building_graph)
     {
@@ -27,15 +28,13 @@
       int edgeID = InvalidableObject::edgeIdGenerator++;
 
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
+      CWorkflowGraph::allocNodeEdge();
 
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "File Writer Filter";
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 4;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 0;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;
+      CWorkflowGraph::addNode(this->filterID, "File Writer Filter \\n("+this->field->file->getId()+".nc)", 6, 0, 1, data[0]);
 
-      if(CXios::isClient) std::cout<<"CFileWriterFilter::apply filter tag = "<<this->tag<<" start = "<<start_graph<<" end = "<<end_graph<<std::endl;
+      // (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->file->recordXiosAttributes();
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->recordXiosAttributes();
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->recordXiosAttributes();
+
+      // if(CXios::isClient) std::cout<<"CFileWriterFilter::apply filter tag = "<<this->tag<<" start = "<<start_graph<<" end = "<<end_graph<<std::endl;
 
       if(CXios::isClient && CWorkflowGraph::build_begin) 
Index: XIOS/dev/dev_trunk_omp/src/filter/filter.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/filter.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/filter.hpp	(revision 1680)
@@ -68,5 +68,5 @@
 
       int filterID;
-      StdString op_expression;
+      StdString expression;
 
     protected:
Index: XIOS/dev/dev_trunk_omp/src/filter/garbage_collector.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/garbage_collector.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/garbage_collector.cpp	(revision 1680)
@@ -8,4 +8,7 @@
   int InvalidableObject::edgeIdGenerator = 0;
   #pragma omp threadprivate(InvalidableObject::edgeIdGenerator)
+
+  int InvalidableObject::clusterIdGenerator = 0;
+  #pragma omp threadprivate(InvalidableObject::clusterIdGenerator)
   
   void CGarbageCollector::registerObject(InvalidableObject* Object, Time timestamp)
Index: XIOS/dev/dev_trunk_omp/src/filter/garbage_collector.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/garbage_collector.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/garbage_collector.hpp	(revision 1680)
@@ -28,4 +28,7 @@
     static int edgeIdGenerator;
     #pragma omp threadprivate(edgeIdGenerator)
+
+    static int clusterIdGenerator;
+    #pragma omp threadprivate(clusterIdGenerator)
 
     
Index: XIOS/dev/dev_trunk_omp/src/filter/output_pin.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/output_pin.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/output_pin.cpp	(revision 1680)
@@ -116,11 +116,9 @@
     {
 
-      if(parent_filters[i]->start_graph==0) parent_filters[i]->start_graph = start_graph;
-      else if(parent_filters[i]->start_graph<0) parent_filters[i]->start_graph = start_graph;
+      if(parent_filters[i]->start_graph<0) parent_filters[i]->start_graph = start_graph;
       else parent_filters[i]->start_graph = min(parent_filters[i]->start_graph, start_graph);
 
 
-      if(parent_filters[i]->end_graph==9223372036854775807) parent_filters[i]->end_graph = end_graph;  
-      else if(parent_filters[i]->end_graph<0) parent_filters[i]->end_graph = end_graph;  
+      if(parent_filters[i]->end_graph<0) parent_filters[i]->end_graph = end_graph;  
       else parent_filters[i]->end_graph = max(parent_filters[i]->end_graph, end_graph);
       
Index: XIOS/dev/dev_trunk_omp/src/filter/pass_through_filter.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/filter/pass_through_filter.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/filter/pass_through_filter.cpp	(revision 1680)
@@ -2,4 +2,5 @@
 #include "workflow_graph.hpp"
 #include "field.hpp"
+#include "file.hpp"
 
 namespace xios
@@ -16,17 +17,15 @@
     if(building_graph)
     {
-      std::cout<<"CPassThroughFilter::apply tag = "<<this->tag<<" start = "<<start_graph<<" end = "<<end_graph<<std::endl;
+      // std::cout<<"CPassThroughFilter::apply tag = "<<this->tag<<" start = "<<start_graph<<" end = "<<end_graph<<std::endl;
       this->filterID = InvalidableObject::filterIdGenerator++;
       int edgeID = InvalidableObject::edgeIdGenerator++;
-      if(CWorkflowGraph::mapFilters_ptr_with_info==0) CWorkflowGraph::mapFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_node>;
 
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_name = "Pass Through Filter";
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_class = 5;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].filter_filled = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].expected_entry_nb = 1;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].date = data[0]->date;
-      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].timestamp = data[0]->timestamp;
+      CWorkflowGraph::allocNodeEdge();
 
-      if(CWorkflowGraph::mapFieldToFilters_ptr_with_info==0) CWorkflowGraph::mapFieldToFilters_ptr_with_info = new std::unordered_map <int, graph_info_box_edge >;
+      CWorkflowGraph::addNode(this->filterID, "Pass Through Filter", 2, 1, 1, data[0]);
+
+      (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes = this->field->recordXiosAttributes();
+      if(this->field->file) (*CWorkflowGraph::mapFilters_ptr_with_info)[this->filterID].attributes += "</br>file attributes : </br>" +this->field->file->recordXiosAttributes();
+
       
       if(CWorkflowGraph::build_begin)
